package ru.somecompany.domain;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.UUID;

@Data
@Entity
@Builder
@Table(name = "vacancy")
@AllArgsConstructor
@NoArgsConstructor
public class VacancyEntity {

    @Id
    @GeneratedValue
    private UUID id;

    @Column(name = "name", nullable = false)
    private String name;

    @Column(name = "description", nullable = true, length = 1000)
    private String description;

    @Column(name = "salary_low", nullable = false)
    private Integer salaryLow;

    @Column(name = "salary_high", nullable = false)
    private Integer salaryHigh;

    @Column(name = "company_id", nullable = false)
    private UUID companyId;
}
