import os
import random
import string


def generate_random_filename(length):
    #Генерирует случайное имя файла с длиной length.
    return ''.join(random.choices(string.ascii_lowercase + string.digits, k=length)) + '.txt'


def generate_data_files(directory, num_files, min_lines, max_lines):

    # Создание директории, если таковой не существует
    if not os.path.exists(directory):
        os.makedirs(directory)

    # Проверка, пустая ли директория
    if os.listdir(directory):
        print(f"{directory} is not empty, skipping file generation.")
        return

    # Генерация файлов
    for _ in range(num_files):
        file_name = generate_random_filename(random.randint(5, 20))  # Длина имени файла от 5 до 20
        file_path = os.path.join(directory, file_name)

        # Создание пустого файла
        open(file_path, 'w').close()  # Открываем файл в режиме записи и сразу закрываем

        print(f"Generated file: {file_path}")


if __name__ == "__main__":
    # Генерация случайных файлов данных в директории /var/data
    generate_data_files('/var/data', num_files=random.randint(5, 15), min_lines=1, max_lines=50)
